/** \file oatest.cpp

 C++ program: oatest

 oatest: tool for testing new algorithms

 Author: Pieter Eendebak <pieter.eendebak@gmail.com>, (C) 2014

 Copyright: See LICENSE.txt file that comes with this distribution
*/

#include <stdio.h>
#include <stdlib.h>
#include <iostream>
#include <algorithm>

#include "arraytools.h"
#include "arrayproperties.h"
#include "anyoption.h"
#include "tools.h"
#include "extend.h"

#include "oadevelop.h"
#include "lmc.h"

struct conference_t {
	rowindex_t N;	/** number of runs */
	colindex_t ncols;	/** total number of columns (factors) in the design */

public:
	/// create new arraydata_t object
	conference_t ( int N, int k );
};


conference_t::conference_t(int N, int k)
{
		this->N = N; this->ncols = k;
}

array_link create_conference_root(const conference_t c)
{
		array_link al(c.N, c.ncols, 0);
		
		for(int i=1; i<c.N; i++) {
				al.at(i, 0) = 1;
		}
		for(int i=0; i<c.N; i++) {
			if (i==1)
				continue;
			if (i<c.N/2 ) 
				al.at(i, 1) = 1;
			else
				al.at(i, 1) = -1;
		}

		return al;
	
}

struct conference_extend_t {
	std::vector<array_link> first;
	std::vector<array_link> second;
	

public:
};


void extend_conference(const array_link al, const conference_t)
{

	// first create two sets of partial extensions
	
	
	// perform row symmetry check
	
	// perform inner product check
	
	
	
}
int main ( int argc, char* argv[] )
{
	AnyOption opt;
	/* parse command line options */
	opt.setFlag ( "help", 'h' );   /* a flag (takes no argument), supporting long and short form */
	opt.setOption ( "output", 'o' );
	opt.setOption ( "verbose", 'v' );
	opt.setOption ( "ii", 'i' );
	opt.setOption ( "rows" );
	opt.setOption ( "cols" );
	opt.setOption ( "oaconfig", 'c' ); /* file that specifies the design */

	opt.addUsage ( "Orthonal Array: oaconference: testing platform" );
	opt.addUsage ( "Usage: oaconference [OPTIONS] [FILE]" );
	opt.addUsage ( "" );
	opt.addUsage ( " -h --help  			Prints this help " );
	opt.processCommandArgs ( argc, argv );


	print_copyright();
	//cout << system_uname();
	setloglevel ( NORMAL );

		int verbose = opt.getIntValue ( 'v', 1 );

	/* parse options */
	if ( opt.getFlag ( "help" ) || opt.getFlag ( 'h' ) || opt.getArgc() <0 ) {
		opt.printUsage();
		exit ( 0 );
	}

	setloglevel ( SYSTEM );

	int N=10;
	int k=10;
	conference_t ctype(N, k);
	
	if (verbose)
		printf("create conference matrices of size %dx%d\n", ctype.N, ctype.ncols);
	array_link al = create_conference_root(ctype);
	
	printf("root array:\n");
	al.showarray();


	 extend_conference(al, ctype); 
	 
		printf("done...\n");

	return 0;

}

// kate: indent-mode cstyle; indent-width 4; replace-tabs off; tab-width 4; 
